//from
//http://vision.kuee.kyoto-u.ac.jp/~hiroaki/firewire/directshow.html
#include <dshow.h>
#include <iostream>
#include <math.h>

using namespace std;
#pragma comment(lib, "strmbasd.lib")


HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) 
{
    IMoniker * pMoniker;
    IRunningObjectTable *pROT;
    if (FAILED(GetRunningObjectTable(0, &pROT))) {
        return E_FAIL;
    }
    WCHAR wsz[256];
    wsprintfW(wsz, L"FilterGraph %08p pid %08x", (DWORD_PTR)pUnkGraph, GetCurrentProcessId());
    HRESULT hr = CreateItemMoniker(L"!", wsz, &pMoniker);
    if (SUCCEEDED(hr)) {
        hr = pROT->Register(0, pUnkGraph, pMoniker, pdwRegister);
        pMoniker->Release();
    }
    pROT->Release();
    return hr;
}

void RemoveFromRot(DWORD pdwRegister)
{
    IRunningObjectTable *pROT;
    if (SUCCEEDED(GetRunningObjectTable(0, &pROT))) {
        pROT->Revoke(pdwRegister);
        pROT->Release();
    }
}

#define NCAM 2

int main(int argc, char* argv[])
{
  HRESULT hr;
  CoInitialize(NULL);

  // 1. tB^Ot쐬
  IGraphBuilder *pGraph = NULL;
  CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
      IID_IGraphBuilder, (void **)&pGraph);
  DWORD dwRegister;
  hr = AddToRot(pGraph, &dwRegister);

  // 2. VXefoCX񋓎q쐬
  ICreateDevEnum *pDevEnum = NULL;
  CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
      IID_ICreateDevEnum, (void **)&pDevEnum);
  IEnumMoniker *pClassEnum = NULL;
  pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
  ULONG cFetched;
  IMoniker *pMoniker = NULL;
  IBaseFilter *pSrc[NCAM];
  int i;
  for(i=0; i < NCAM; i++){
    if (pClassEnum->Next(1, &pMoniker, &cFetched) == S_OK){
      // NCAMԖڂ̃jJ܂ŃtB^IuWFNgɃoCh
      pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void **)&pSrc[i]);
      pMoniker->Release();
    }
    pGraph->AddFilter(pSrc[i], L"Video Capture");
  }
  pClassEnum->Release();
  pDevEnum->Release();

  // 3. Lv`r_̍쐬
  ICaptureGraphBuilder2 *pBuilder[NCAM];
  for(i=0; i < NCAM; i++){
    CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC,
        IID_ICaptureGraphBuilder2, (void **)&pBuilder[i]);


		// 3.5 IAMStreamConfigC^tF[X̎擾
		IAMStreamConfig *pConfig;
		pConfig=0;

		pBuilder[i]->FindInterface(&PIN_CATEGORY_CAPTURE,&MEDIATYPE_Video,
			pSrc[i],IID_IAMStreamConfig,(void**)&pConfig);

   		//摜TCYCt[[g̐ݒ
        double fps=30;
        int wx=640,wy=480;
		AM_MEDIA_TYPE *pmt[NCAM];
		pConfig->GetFormat(&pmt[i]);
		VIDEOINFOHEADER *vh = (VIDEOINFOHEADER*)pmt[i]->pbFormat;
		vh->bmiHeader.biWidth =wx;
		vh->bmiHeader.biHeight=wy; 
		vh->AvgTimePerFrame= (REFERENCE_TIME)floor((10000000.0/fps+0.5));
		pConfig->SetFormat(pmt[i]);
//		if(ewc_hr!=S_OK){errcode=11; goto fin;}
		pConfig->Release();
		pConfig=0;	
	
	pBuilder[i]->SetFiltergraph(pGraph);
    // fBXvC
    pBuilder[i]->RenderStream( &PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video, pSrc[i], NULL, NULL );
  }

  // 5. Lv`Jn
  IMediaControl *pMediaControl;
  pGraph->QueryInterface(IID_IMediaControl, (void **)&pMediaControl);
  pMediaControl->Run();
  MessageBox(NULL, "Click to stop.", "DirectShow", MB_OK);

  // 6. I
  for(i=0; i < NCAM; i++){
    pSrc[i]->Release();
    pBuilder[i]->Release();
  }
  pMediaControl->Release();
  RemoveFromRot(dwRegister);
  pGraph->Release();

  CoUninitialize();
  return 0;
}
